"use strict";

var _vue = _interopRequireDefault(require("vue"));

var _utils = require("./utils");

var _ThemeProvider = _interopRequireDefault(require("../providers/ThemeProvider"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n      color: ", ";\n    "]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n      color: ", ";\n    "]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n      color: ", ";\n    "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var styled;
describe('props', function () {
  beforeEach(function () {
    styled = (0, _utils.resetStyled)();
  });
  it('should execute interpolations and fall back', function () {
    var compProps = {
      fg: String
    };
    var Comp = styled('div', compProps)(_templateObject(), function (props) {
      return props.fg || 'black';
    });
    var vm = new _vue["default"](Comp).$mount();
    (0, _utils.expectCSSMatches)('.a {color: black;}');
  });
  it('should execute interpolations and inject props', function () {
    var compProps = {
      fg: String
    };
    var Comp = styled('div', compProps)(_templateObject2(), function (props) {
      return props.fg || 'black';
    });

    var Ctor = _vue["default"].extend(Comp);

    var vm = new Ctor({
      propsData: {
        fg: 'red'
      }
    }).$mount();
    (0, _utils.expectCSSMatches)('.a {color: red;}');
  });
  it('should add any injected theme to the component', function () {
    var theme = {
      blue: "blue"
    };
    var Comp = styled.div(_templateObject3(), function (props) {
      return props.theme.blue;
    });
    var Themed = {
      render: function render(createElement) {
        return createElement(_ThemeProvider["default"], {
          props: {
            theme: theme
          }
        }, [createElement(Comp)]);
      }
    };
    var vm = new _vue["default"](Themed).$mount();
    (0, _utils.expectCSSMatches)('.a {color: blue;}');
  });
});