"use strict";

var _vue = _interopRequireDefault(require("vue"));

var _chai = require("chai");

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _templateObject() {
  var data = _taggedTemplateLiteral(["color: blue;"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var styled;
describe('extending styled', function () {
  beforeEach(function () {
    styled = (0, _utils.resetStyled)();
  });
  it('should change the target element', function () {
    var OldTarget = styled.div(_templateObject());
    var NewTarget = OldTarget.withComponent('a');
    var o = new _vue["default"](OldTarget).$mount();
    var n = new _vue["default"](NewTarget).$mount();
    (0, _chai.assert)(o._vnode.tag === 'div');
    (0, _chai.assert)(n._vnode.tag === 'a');
  });
});